wb_usr = {
   contact : "lua@bazar2.conectiva.com.br?body=\"The e-mail above is of 'Lua list', to send e-mail to it you need to be a member of it, to become a member, or get more info about the list, go to http://bazar2.conectiva.com.br/mailman/listinfo/lua\"",
   copyright_link : "http://www.lua.org/copyright.html",
   copyright_name : "Copyright  2003 TeCGraf, PUC-Rio. All rights reserved",
   title_bgcolor : "midnightblue",
   langs : ["en"],
   start_size : "240",
   use_items : "yes",
   use_folders : "yes",
   start_open : "no"
};

wb_usr.messages = {
  en : {
     revision_date : "2 Nov 2003",
     title : "Lua 5.0 Reference Manual",
     bar_title : "Lua 5.0 Reference Manual"
  }
};


wb_usr.tree =
{
  name: { en: "Lua" },
  link: "manual.html",
  folder:
  [
	{
	  name: { en: "Introduction" },
	  link: "manual.html#intro"	
	},
	{
	  name: { en: "The Language" },
	  link: "manual.html#language",
	  folder:
	  [
		{
		  name: { en: "Lexical Conventions" },
		  link: "manual.html#lexical"		
		},
		{
		  name: { en: "Values and Types" },
		  link: "manual.html#typessec",
		  folder:
		  [
			{
			  name: { en: "Coercion" },
			  link: "manual.html#coercion"			
			}
		  ]
		},
		{
		  name: { en: "Variables" },
		  link: "manual.html#variables"		
		},
		{
		  name: { en: "Statements" },
		  link: "manual.html#stats",
		  folder:
		  [
			{
			  name: { en: "Chunks" },
			  link: "manual.html#chunks"			
			},
			{
			  name: { en: "Blocks" },
			  link: "manual.html#blocks"			
			},
			{
			  name: { en: "Assignment" },
			  link: "manual.html#assignment"			
			},
			{
			  name: { en: "Control Structures" },
			  link: "manual.html#control"			
			},
			{
			  name: { en: "For Statement" },
			  link: "manual.html#for"			
			},
			{
			  name: { en: "Function Calls as Statements" },
			  link: "manual.html#funcstat"			
			},
			{
			  name: { en: "Local Declarations" },
			  link: "manual.html#localvar"			
			}
		  ]
		},
		{
		  name: { en: "Expressions" },
		  link: "manual.html#expressions",
		  folder:
		  [
			{
			  name: { en: "Arithmetic Operators" },
			  link: "manual.html#arith-ops"			
			},
			{
			  name: { en: "Relational Operators" },
			  link: "manual.html#rel-ops"			
			},
			{
			  name: { en: "Logical Operators" },
			  link: "manual.html#log-ops"			
			},
			{
			  name: { en: "Concatenation" },
			  link: "manual.html#concat"			
			},
			{
			  name: { en: "Precedence" },
			  link: "manual.html#precedence"			
			},
			{
			  name: { en: "Table Constructors" },
			  link: "manual.html#tableconstructor"			
			},
			{
			  name: { en: "Function Calls" },
			  link: "manual.html#functioncall"			
			},
			{
			  name: { en: "Function Definitions" },
			  link: "manual.html#func-def"			
			}
		  ]
		},
		{
		  name: { en: "Visibility Rules" },
		  link: "manual.html#visibility"		
		},
		{
		  name: { en: "Error Handling" },
		  link: "manual.html#error"		
		},
		{
		  name: { en: "Metatables" },
		  link: "manual.html#metatable"		
		},
		{
		  name: { en: "Garbage Collection" },
		  link: "manual.html#gc",
		  folder:
		  [
			{
			  name: { en: "Garbage-Collection Metamethods" },
			  link: "manual.html#gc-meta"			
			},
			{
			  name: { en: "Weak Tables" },
			  link: "manual.html#weak-table"			
			}
		  ]
		},
		{
		  name: { en: "Coroutines" },
		  link: "manual.html#coroutine"		
		}
	  ]
	},
	{
	  name: { en: "The Application Program Interface" },
	  link: "manual.html#api",
	  folder:
	  [
		{
		  name: { en: "States" },
		  link: "manual.html#mangstate"		
		},
		{
		  name: { en: "The Stack and Indices" },
		  link: "manual.html#stack"		
		},
		{
		  name: { en: "Stack Manipulation" },
		  link: "manual.html#stack-man"		
		},
		{
		  name: { en: "Querying the Stack" },
		  link: "manual.html#stack-quer"		
		},
		{
		  name: { en: "Getting Values from the Stack" },
		  link: "manual.html#lua-to"		
		},
		{
		  name: { en: "Pushing Values onto the Stack" },
		  link: "manual.html#pushing"		
		},
		{
		  name: { en: "Controlling Garbage Collection" },
		  link: "manual.html#gc-api"		
		},
		{
		  name: { en: "Userdata" },
		  link: "manual.html#userdata"		
		},
		{
		  name: { en: "Metatables" },
		  link: "manual.html#metatables"		
		},
		{
		  name: { en: "Loading Lua Chunks" },
		  link: "manual.html#load-chunk"		
		},
		{
		  name: { en: "Manipulating Tables" },
		  link: "manual.html#tables"		
		},
		{
		  name: { en: "Manipulating Environments" },
		  link: "manual.html#globals"		
		},
		{
		  name: { en: "Using Tables as Arrays" },
		  link: "manual.html#arrays"		
		},
		{
		  name: { en: "Calling Functions" },
		  link: "manual.html#functions"		
		},
		{
		  name: { en: "Protected Calls" },
		  link: "manual.html#lua_pcall"		
		},
		{
		  name: { en: "Defining C Functions" },
		  link: "manual.html#luacallc"		
		},
		{
		  name: { en: "Defining C Closures" },
		  link: "manual.html#c-closure"		
		},
		{
		  name: { en: "Registry" },
		  link: "manual.html#registry"		
		},
		{
		  name: { en: "Error Handling in C" },
		  link: "manual.html#error-hand"		
		},
		{
		  name: { en: "Threads (or Coroutines)" },
		  link: "manual.html#threads"		
		}
	  ]
	},
	{
	  name: { en: "The Debug Interface" },
	  link: "manual.html#debugi",
	  folder:
	  [
		{
		  name: { en: "Stack and Function Information" },
		  link: "manual.html#stack-func"		
		},
		{
		  name: { en: "Manipulating Local Variables and Upvalues" },
		  link: "manual.html#loc-up-vars"		
		},
		{
		  name: { en: "Hooks" },
		  link: "manual.html#sub-hooks"		
		}
	  ]
	},
	{
	  name: { en: "Standard Libraries" },
	  link: "manual.html#libraries",
	  folder:
	  [
		{
		  name: { en: "Basic Functions" },
		  link: "manual.html#predefined"		
		},
		{
		  name: { en: "Coroutine Manipulation" },
		  link: "manual.html#cor-man"		
		},
		{
		  name: { en: "String Manipulation" },
		  link: "manual.html#string"		
		},
		{
		  name: { en: "Table Manipulation" },
		  link: "manual.html#tab-man"		
		},
		{
		  name: { en: "Mathematical Functions" },
		  link: "manual.html#mathlib"		
		},
		{
		  name: { en: "Input and Output Facilities" },
		  link: "manual.html#libio"		
		},
		{
		  name: { en: "Operating System Facilities" },
		  link: "manual.html#libiosys"		
		},
		{
		  name: { en: "The Reflexive Debug Interface" },
		  link: "manual.html#reflexive"		
		}
	  ]
	},
	{
	  name: { en: "Lua Stand-alone" },
	  link: "manual.html#lua-sa"	
	},
	{
	  name: { en: "Acknowledgments" },
	  link: "manual.html#acknow"	
	},
	{
	  name: { en: "Incompatibilities with Previous Versions" },
	  link: "manual.html#incompat"	
	},
	{
	  name: { en: "The Complete Syntax of Lua" },
	  link: "manual.html#BNF"	
	}
  ]
};